// -----------------------------------------------------------------------------
// This file contains all application-wide Sass mixins.
// -----------------------------------------------------------------------------

/// Event wrapper
/// @author Harry Roberts
/// @param {Bool} $self [false] - Whether or not to include current selector
/// @link https://twitter.com/csswizardry/status/478938530342006784 Original tweet from Harry Roberts
@mixin on-event($self: false) {
  @if $self {
    &,
    &:hover,
    &:active,
    &:focus {
      @content;
    }
  } @else {
    &:hover,
    &:active,
    &:focus {
      @content;
    }
  }
}

/// Make a context based selector a little more friendly
/// @author Hugo Giraudel
/// @param {String} $context
@mixin when-inside($context) {
  #{$context} & {
    @content;
  }
}

/// Linear gradient
/// @param {String} $from, {String} $to
@mixin linear-gradient($from, $to) {
	background: $to;
	background: -moz-linear-gradient(top, $from 0%, $to 100%);
	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,$from), color-stop(100%,$to));
	background: -webkit-linear-gradient(top, $from 0%, $to 100%);
	background: -o-linear-gradient(top, $from 0%, $to 100%);
	background: linear-gradient(to bottom, $from 0%, $to 100%);
	filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0, startColorstr=ie-hex-str($from), endColorstr=ie-hex-str($to));
}


@mixin linear-gradient-complex($angle, $color-stops...) {
	$_angle-with-vendor-prefix: "";
	$_angle: "";

	@if $angle == "to top" or $angle == "bottom" {
		$_angle-with-vendor-prefix: bottom;
		$_angle: to top;
	} @else if $angle == "to right" or $angle == "left" {
		$_angle-with-vendor-prefix: left;
		$_angle: to right;
	} @else if $angle == "to bottom" or $angle == "top" {
		$_angle-with-vendor-prefix: top;
		$_angle: to bottom;
	} @else if $angle == "to left" or $angle == "right" {
		$_angle-with-vendor-prefix: right;
		$_angle: to left;
	} @else if $angle == "to top right" or $angle == "bottom left" {
		$_angle-with-vendor-prefix: bottom left;
		$_angle: to top right;
	} @else if $angle == "to bottom right" or $angle == "top left" {
		$_angle-with-vendor-prefix: top left;
		$_angle: to bottom right;
	} @else if $angle == "to bottom left" or $angle == "top right" {
		$_angle-with-vendor-prefix: top right;
		$_angle: to bottom left;
	} @else if $angle == "to top left" or $angle == "bottom right" {
		$_angle-with-vendor-prefix: bottom right;
		$_angle: to top left;
	} @else {
		//$_angle-with-vendor-prefix: $angle % 360;
		//$_angle: (90 - $angle) % 360;
		$_angle-with-vendor-prefix: (90 - $angle) % 360;
		$_angle: $angle;
	}

	background: -webkit-linear-gradient($_angle-with-vendor-prefix, $color-stops);
	background: -moz-linear-gradient($_angle-with-vendor-prefix, $color-stops);
	background: -o-linear-gradient($_angle-with-vendor-prefix, $color-stops);
	background: linear-gradient($_angle, $color-stops);
}


@mixin scrimGradient($startColor: 'black', $direction: 'to bottom') {
	$scrimCoordinates: (
		0: 1,
		19: 0.738,
		34: 0.541,
		47: 0.382,
		56.5: 0.278,
		65: 0.194,
		73: 0.126,
		80.2: 0.075,
		86.1: 0.042,
		91: 0.021,
		95.2: 0.008,
		98.2: 0.002,
		100: 0
	);

	$hue: hue($startColor);
	$saturation: saturation($startColor);
	$lightness: lightness($startColor);
	$stops: ();

	@each $colorStop, $alphaValue in $scrimCoordinates {
		$stop: hsla($hue, $saturation, $lightness, $alphaValue) percentage($colorStop/100);
		$stops: append($stops, $stop, comma);
	}

	background: linear-gradient(unquote($direction), $stops);
}


/// Transition
/// @param {String} $args
@mixin transition($args...) {
    -webkit-transition: $args;
    -moz-transition: $args;
    -o-transition: $args;
    transition: $args;
}

/// Transform
/// @param {String} $args
@mixin transform($args...) {
    -webkit-transform: $args;
    -moz-transform: $args;
    -o-transform: $args;
    transform: $args;
}

/// Transition Transform
/// @param {String} $args
@mixin transition-transform($args, $preface:webkit moz ms o spec){
  @each $browser in $preface {
    @if( $browser == spec) {
      transition: transform $args;
    } @else {
      //@include prefixer( transition, -#{$browser}-transform $args, $browser);
      -#{$browser}-transition: -#{$browser}-transform $args;
    }
  }
}



/// Multiline Ellipsis
/// @param {Int} $line-clamp
@mixin multiline-ellipsis($line-clamp: null) {
	@if $line-clamp != null {
		-webkit-line-clamp: $line-clamp;
		-webkit-box-orient: vertical;
		overflow: hidden;
		text-overflow: ellipsis;
		display: -webkit-box;
	}
}


// Form mixins

@mixin input-shape($color: null, $border: false) {
	@if ($color != null) { color: $color; }
	padding: 16px 0;
	border-radius: $radius;
	border: none;
	@if ($border) {
	border-bottom: 1px solid $input-border;
	} @else {
	box-shadow: inset 0 0 0 1px $input-border;
	}
	box-sizing: border-box;
	display: block;
	outline: none;
}

@mixin input-shape-focus($color, $border: false) {
	@if ($border) {
	border-color: $color;
	} @else {
	box-shadow: inset 0 0 0 1px $color;
	}
	outline: none;
}


@mixin underline($width: 236px) {
	&:after {
		content: '';
		background-color: $black;
		width: $width;
		height: 2px;
		display: block;
		margin-top: 22px;
	}
}


// Heading and text mixins


/// Heading
/// @param {String} $color
@mixin heading($color: null) {
	font-family: $heading-font-stack;
	font-weight: normal;
	font-size: 120px;
	line-height: 120px;
	letter-spacing: -0.05em;
	@if ($color != null) { color: $color; }
	margin: 0;
}

/// Heading h1
/// @param {String} $color
@mixin heading-h1($color: null, $weight: 500) {
	font-family: $heading-font-stack;
	font-weight: $weight;
	font-size: 60px;
	line-height: 72px;
	@if ($color != null) { color: $color; }
}

/// Heading h2
/// @param {String} $color
@mixin heading-h2($color: null, $weight: 500) {
	font-family: $heading-font-stack;
	font-weight: $weight;
	font-size: 28px;
	line-height: 40px;
	@if ($color != null) { color: $color; }
}

/// Heading H3
/// @param {String} $color
@mixin heading-h3($color: null, $weight: normal) {
	font-family: $heading-font-stack;
	font-weight: $weight;
	font-size: 40px;
	line-height: 48px;
	@if ($color != null) { color: $color; }
}

/// Heading H4
/// @param {String} $color
@mixin heading-h4($color: null, $weight: normal) {
	font-family: $heading-font-stack;
	font-weight: $weight;
	font-size: 22px;
	line-height: 32px;
	@if ($color != null) { color: $color; }
}


/// Heading H5
/// @param {String} $color
@mixin heading-h5($color: null, $weight: normal) {
	
}



/// Heading Input
/// @param {String} $color
@mixin heading-input($color: null, $weight: normal) {
	font-family: $input-font-stack;
	font-weight: $weight;
	font-size: 18px;
	line-height: 32px;
	@if ($color != null) { color: $color; }
}


/// Body Regular
/// @param {String} $color
@mixin body-regular($color: null, $weight: normal) {
	
}


/// Body Small
/// @param {String} $color
@mixin body-small($color: null, $weight: normal) {
	
}


/// Body Small Mono
/// @param {String} $color
@mixin body-small-mono($color: null, $weight: normal) {
	
}



/// Navigation Link
/// @param {String} $color
@mixin nav-link($color: null) {
	font-family: $navigation-font-stack;
	font-weight: 500;
	font-size: 15px;
	line-height: 24px;
	letter-spacing: 0.05em;
	text-transform: uppercase;
}